package com.egdigital.allzic.ui;

import android.annotation.SuppressLint;
import android.support.v4.view.ViewPager.PageTransformer;
import android.view.View;

/**
 * @author julien
 */
@SuppressLint("NewApi")
public class PagerTransformer implements PageTransformer {

	private static final String	TAG					= PagerTransformer.class.getSimpleName();	// log
	private static float		MIN_SCALE			= 0.75f;
	private static float		MIN_ALPHA			= 0.85f;
	private static final int	ANIMATION_SELECTED	= 2;

	@Override
	public void transformPage(View view, float position) {
		switch (ANIMATION_SELECTED) {
			case 1:
				// view.setRotationY(position * -10);
				int width = view.getWidth();
				int height = view.getHeight();
				if (position < -1) { // [-Infinity,-1)
					// This page is way off-screen to the left.
					view.setAlpha(0);
				} else if (position <= 1) { // [-1,1]
					// Modify the default slide transition to shrink the page as well
					float scaleFactor = Math.max(MIN_SCALE, 1 - Math.abs(position));
					float vertMargin = height * (1 - scaleFactor) / 2;
					float horzMargin = width * (1 - scaleFactor) / 2;
					if (position < 0) {
						view.setTranslationX(horzMargin - vertMargin / 2);
					} else {
						view.setTranslationX(-horzMargin + vertMargin / 2);
					}
					// Scale the page down (between MIN_SCALE and 1)
					view.setScaleX(scaleFactor);
					view.setScaleY(scaleFactor);
					// Fade the page relative to its size.
					view.setAlpha(MIN_ALPHA + (scaleFactor - MIN_SCALE) / (1 - MIN_SCALE) * (1 - MIN_ALPHA));
				} else { // (1,+Infinity]
					// This page is way off-screen to the right.
					view.setAlpha(0);
				}
				break;
			case 2:
				int pageWidth = view.getWidth();
				if (position < -1) { // [-Infinity,-1)
					// This page is way off-screen to the left.
					view.setAlpha(0);
				} else if (position <= 0) { // [-1,0]
					// Use the default slide transition when moving to the left page
					view.setAlpha(1);
					view.setTranslationX(0);
					view.setScaleX(1);
					view.setScaleY(1);
				} else if (position <= 1) { // (0,1]
					// Fade the page out.
					view.setAlpha(1 - position);
					// Counteract the default slide transition
					view.setTranslationX(pageWidth * -position);
					// Scale the page down (between MIN_SCALE and 1)
					float scaleFactor = MIN_SCALE + (1 - MIN_SCALE) * (1 - Math.abs(position));
					view.setScaleX(scaleFactor);
					view.setScaleY(scaleFactor);
				} else { // (1,+Infinity]
					// This page is way off-screen to the right.
					view.setAlpha(0);
				}
				break;
		}
	}
}
